--[[
	Copyright (C) Udorn (Blackhand)
--]]

petbm = petbm or {}

petbm.PetBattleMaster = LibStub("AceAddon-3.0"):NewAddon("PetBattleMaster", "AceEvent-3.0", "AceConsole-3.0", "AceHook-3.0")
--local L = petbm.Locale.GetInstance()
local log = petbm.Debug:new("PetBattleMaster")

local AceConfigDialog = LibStub("AceConfigDialog-3.0")

local APP_NAME = "PetBattleMaster"

local order = 1

local SCREEN_HEIGHT = GetScreenHeight()
local SCREEN_WIDTH = GetScreenWidth()

local DEFAULT_CONFIG = {}

function petbm.PetBattleMaster:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("PetBattleMasterDb", DEFAULT_CONFIG, "Default")
--	OPTIONS.args.profile = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	
	self.db.RegisterCallback(self, "OnProfileChanged", "ProfileUpdate")
	self.db.RegisterCallback(self, "OnProfileCopied", "ProfileUpdate")
	self.db.RegisterCallback(self, "OnProfileReset", "ProfileUpdate")
end

function petbm.PetBattleMaster:OnEnable()
	log:Debug("OnEnable")
	log:ClearHistory()
	self.view = petbm.MainView.New()
	self.view:Update()
--	LibStub("AceConfig-3.0"):RegisterOptionsTable(APP_NAME, OPTIONS)
--	self.configFrame = AceConfigDialog:AddToBlizOptions(APP_NAME)
	self:RegisterChatCommand("petbm", "ChatCommand")
	
	self:RegisterEvent("PET_BATTLE_PET_CHANGED")	
	--self:RegisterEvent("PET_BATTLE_OPENING_START")
	self:RegisterEvent("PET_BATTLE_OPENING_DONE")
	--self:RegisterEvent("PET_BATTLE_OVER")
	self:RegisterEvent("PET_BATTLE_CLOSE")
	self:SecureHook("PetBattleFrame_ShowMultiWildNotification")
end

function petbm.PetBattleMaster:ProfileUpdate(event)
	log:Debug("ProfileUpdate event [%s]", event)
	self.view:ProfileUpdate()
end

function petbm.PetBattleMaster:ChatCommand(msg)
	log:Debug("msg [%s]", msg)
	if ("debug" == msg) then
		if (log:IsDebugging()) then
			print("Turning off debugging")
			log:SetDebugging(nil)
		else
			print("Turning on debugging")
			log:SetDebugging(true)
		end
	elseif ("history" == msg) then
		print("Printing history")
		log:PrintHistory()
	elseif ("clear" == msg) then
		print("Clearing history")
		log:ClearHistory()
--	else
--		InterfaceOptionsFrame_OpenToCategory(self.configFrame)
	end
end

function petbm.PetBattleMaster.Print(self, msg)
	print("|cFF3DDEFF"..msg.."|r")
end

function petbm.PetBattleMaster:PET_BATTLE_PET_CHANGED()
	log:Debug("PET_BATTLE_PET_CHANGED")
	self.view:Update()
end

function petbm.PetBattleMaster:PetBattleFrame_ShowMultiWildNotification()
	log:Debug("PetBattleFrame_ShowMultiWildNotification")
	self.view:Update()
end

function petbm.PetBattleMaster:PET_BATTLE_OPENING_DONE()
	log:Debug("PET_BATTLE_OPENING_DONE")
	self.view:Open()
	self.view:Update()
end

function petbm.PetBattleMaster:PET_BATTLE_CLOSE()
	log:Debug("PET_BATTLE_CLOSE")
	self.view:Close()
end
